
typedef  void( *ForEachUrlCallBack)(LPCWSTR url);




class MyParser : public IPropertyNotifySink, IOleClientSite, IDispatch
{
public:
	MyParser();
			
    ~MyParser();
   
	ForEachUrlCallBack forEachImage;
	ForEachUrlCallBack forEachLink;


	//HRESULT Uninit();
	/*
	{
		HRESULT hr = NOERROR;

		if (m_pWinSink)
		{
			m_pWinSink->Uninit();
			m_pWinSink->Release();
			m_pWinSink = NULL;
		}

		if (m_pMSHTML)
		{
			m_pMSHTML->Release();
			m_pMSHTML = NULL;
		}

		return NOERROR;
	}
	*/


	// IUnknown methods
    STDMETHOD(QueryInterface)(REFIID riid, LPVOID* ppv);
    STDMETHOD_(ULONG, AddRef)();
    STDMETHOD_(ULONG, Release)();

	// IPropertyNotifySink methods
    STDMETHOD(OnChanged)(DISPID dispID);
    STDMETHOD(OnRequestEdit)(DISPID dispID);

	// IOleClientSite methods
	STDMETHOD(SaveObject)(void) { return E_NOTIMPL; }

	STDMETHOD(GetMoniker)(DWORD dwAssign,
            DWORD dwWhichMoniker,
            IMoniker** ppmk)
			{  return E_NOTIMPL; }

	STDMETHOD(GetContainer)(IOleContainer** ppContainer)
			{  return E_NOTIMPL; }

	STDMETHOD(ShowObject)(void)
			{ return E_NOTIMPL; }

    STDMETHOD(OnShowWindow)(BOOL fShow)
			{  return E_NOTIMPL; }

    STDMETHOD(RequestNewObjectLayout)(void)
			{  return E_NOTIMPL; }

	// IDispatch method
	STDMETHOD(GetTypeInfoCount)(UINT* pctinfo)
			{  return E_NOTIMPL; }

	STDMETHOD(GetTypeInfo)(UINT iTInfo,
            LCID lcid,
            ITypeInfo** ppTInfo)
			{return E_NOTIMPL; }

	STDMETHOD(GetIDsOfNames)(REFIID riid,
            LPOLESTR* rgszNames,
            UINT cNames,
            LCID lcid,
            DISPID* rgDispId)
			{ return E_NOTIMPL; }

	STDMETHOD(Invoke)(DISPID dispIdMember,
            REFIID riid,
            LCID lcid,
            WORD wFlags,
            DISPPARAMS __RPC_FAR *pDispParams,
            VARIANT __RPC_FAR *pVarResult,
            EXCEPINFO __RPC_FAR *pExcepInfo,
            UINT __RPC_FAR *puArgErr);

	// Additional class methods
	//BOOL Init();

	BOOL parseUrl(LPCTSTR url, UrlVector& urlVector, DWORD urlType);
	/*
	{			
		if (SUCCEEDED(LoadURLFromMoniker(url)))
		{
			if (SUCCEEDED(Run()))
			{
				return TRUE;
			}
		}
		return FALSE;
	}
	*/

#if 0
	BOOL parseFile(LPCTSTR fileName)
	{
		if (SUCCEEDED(LoadURLFromFile(fileName)))
		{
			if (SUCCEEDED(Run()))
			{
				return TRUE;
			}
		}
		return FALSE;
	}


	BOOL parseBuffer2(LPBYTE buffer, DWORD size)
	{	
		if (myStream.init(buffer, size))
		{
			if (SUCCEEDED(LoadURLFromStream()))
			{
				return TRUE;
			}
		}
		return FALSE;
	}
	BOOL parseBuffer3(LPBYTE buffer, DWORD size)
	{
		/*
		if (CreatePointerMoniker(
			if (SUCCEEDED(LoadURLFromStorage()))
			{
				return TRUE;
			}
		}
		*/
		return FALSE;
	}


	BOOL parseBuffer(LPBYTE buffer, DWORD size)
	{
		/*
		if (myStream.init(buffer, size))
		{
			if (SUCCEEDED(LoadURLFromStream()))
			{
				return TRUE;
			}
		}
		*/
		HGLOBAL hGlobal;
		hGlobal = GlobalAlloc(GPTR, size + 2);
		LPVOID pMem = GlobalLock(hGlobal);
		memcpy(pMem, buffer, size);
		if (SUCCEEDED(CreateStreamOnHGlobal(buffer, TRUE, &pStream)))
		{
			if (SUCCEEDED(LoadURLFromStream2()))
			{
				return TRUE;
			}
		}
		return FALSE;
	}
#endif

	HRESULT WalkAll(UrlVector& urlVector, DWORD urlType);
/*
	HRESULT Run();
	HRESULT Term();
	HRESULT Walk();
	HRESULT GetUA(BSTR* pbstrUA);
*/
	HRESULT GetUA(BSTR* pbstrUA);

protected:
	//CMyStream myStream;
	//IStream* pStream;
	// Persistence helpers
	HRESULT LoadURLFromFile(LPCTSTR fileName);
	HRESULT LoadURLFromMoniker(LPCTSTR url);
	//HRESULT LoadURLFromStream();
	//HRESULT LoadURLFromStream2();
	//HRESULT LoadURLFromStorage();


	IHTMLDocument2* m_pMSHTML;
	DWORD m_dwRef;
	DWORD m_dwCookie;
	LPCONNECTIONPOINT m_pCP;
	//HRESULT m_hrConnected;
	LPCTSTR m_szURL;
	INTERNET_SCHEME m_nScheme;
	READYSTATE m_lReadyState;

	INTERNET_SCHEME GetScheme(LPCTSTR szURL);

	CWinSink* m_pWinSink;
	HANDLE m_event;
	BOOL   hasError;
};